C      Format of the call is ,
C      [yy,yp,xmeas,xmv,wspace]=tefunc(nn,time,yy,xmeas,xmv,deltat,wspace)
C      This program integrates at every one second from time to
C      time+deltat, at the end of which it return LHS


C      This Program is to interface matlab with TEFUNC(NN,TIME,YY,YP)
C      Given NN , which is chosen in matlab, we call TEINIT in
C      FORTRAN initilize TIME YY and YP. 
C
C      Program written by : Palavajjhala Srinivas
C                           Washington Univ., St.Louis,MO 63139.
C
C      This program is the main gateway to MATLAB. 
C      When a MEX function is executed MATLAB calls the USRFCN 
C      Subroutine in the corresponding MEX file
C
C      This part should not be modified
       SUBROUTINE mexFunction(NLHS,PLHS,NRHS,PRHS)
       INTEGER NLHS,NRHS
       INTEGER*4 PLHS(*),PRHS(*)

       Integer mxGetM, mxGetPr, mxCreateFull
C       INTEGER*4 GETSTR
C       INTEGER*4 CRTMAT,REALP,IMAGP,GETGLO,ALREAL,ALINT
       DOUBLE PRECISION GETSCA

C
C      Declaration of the pointers          
       INTEGER*4  NNP,TIMEP,YYP,YPP,XMEASP,XMVP,XMEASNP,XMVNP
       INTEGER*4 WSPACEP,WSPACENP,YYNP
       INTEGER*4 DELTATP
       INTEGER I,J

C      Local Variables are
       DOUBLE PRECISION YYL(50),YPL(50),TIMEL,NNL,WSPACE(869)
       DOUBLE PRECISION DTL,DELTATL

C      COMMON DECLARATIONS
       DOUBLE PRECISION XMEAS,XMV
       INTEGER WTEPROC1,WWLK1
       DOUBLE PRECISION WTEPROC,WWLK,WCONST,WRANDSD
       INTEGER WIDV
       COMMON/PV/XMEAS(41),XMV(12)
       COMMON/TEPROC/WTEPROC(580),WTEPROC1(12)
       COMMON/WLK/WWLK(132),WWLK1(12)
       COMMON/CONST/WCONST(112)
       COMMON/RANDSD/WRANDSD
       COMMON/DVEC/WIDV(20)


C      Check for appropriate inputs

C      Create a matrix for return arguments i.e. yp
       PLHS(1)=mxCreateFull(50,1,0)
       PLHS(2)=mxCreateFull(50,1,0)
       PLHS(3)=mxCreateFull(41,1,0)
       PLHS(4)=mxCreateFull(12,1,0) 
       PLHS(5)=mxCreateFull(869,1,0)

C      Assign pointers to the parameters
       NNP=mxGetPr(PRHS(1))
       TIMEP=mxGetPr(PRHS(2))
       YYP=mxGetPr(PRHS(3))
       XMEASP=mxGetPr(PRHS(4))
       XMVP=mxGetPr(PRHS(5))
       DELTATP=mxGetPr(PRHS(6))
       WSPACEP=mxGetPr(PRHS(7))
       YYNP=mxGetPr(PLHS(1))
       YPP=mxGetPr(PLHS(2))
       XMEASNP=mxGetPr(PLHS(3))
       XMVNP=mxGetPr(PLHS(4))
       WSPACENP=mxGetPr(PLHS(5))

C      Copying data out of MATLAB into local variables
       CALL mxCopyPtrToReal8(NNP,NNL,1)
       CALL mxCopyPtrToReal8(TIMEP,TIMEL,1)
       CALL mxCopyPtrToReal8(YYP,YYL,50)
       CALL mxCopyPtrToReal8(XMEASP,XMEAS,41)
       CALL mxCopyPtrToReal8(XMVP,XMV,12)
       CALL mxCopyPtrToReal8(DELTATP,DELTATL,1)
       CALL mxCopyPtrToReal8(WSPACEP,WSPACE,869)

C      Reassign
       DO 10 I=1,580
10     WTEPROC(I)=WSPACE(I)
       DO 15 I=581,592
15     WTEPROC1(I-580)=WSPACE(I)
       DO 20 I=593,724
20     WWLK(I-592)=WSPACE(I)
       DO 25 I=725,736
25     WWLK1(I-724)=WSPACE(I)
       DO 30 I=737,848
30     WCONST(I-736)=WSPACE(I)
       WRANDSD=WSPACE(849)
       DO 40 I=850,869
40     WIDV(I-849)=WSPACE(I)   

C      Integrate form time=timel to time=timel+deltatl*dtl
C      at intervals of 1sec
       DTL=1./3600
       DO 50 I=1,int(DELTATL)
C      Call the subroutine
       CALL TEFUNC(int(NNL),TIMEL,YYL,YPL)
       TIME1=TIME1+DTL
       DO 45 J=1,NNL
         YYL(J)=YYL(J)+YPL(J)*DTL
45     CONTINUE
50     CONTINUE

C      Assign wspace 
       DO 60 I=1,580
60      WSPACE(I)=WTEPROC(I)
       do 65 i=581,592
65     WSPACE(I)=WTEPROC1(I-580)
       DO 70 I=593,724
70       WSPACE(I)=WWLK(I-592)
       DO 75 I=725,736
75     WSPACE(I)=WWLK1(I-724)
       DO 80 I=737,848
80        WSPACE(I)=WCONST(I-736)
       WSPACE(849)=WRANDSD
       DO 90 I=850,869
90     WSPACE(I)=WIDV(I-849)     

C      Copy the data from the local variable into MATLAB return argument
       CALL mxCopyReal8toPtr(YYL,YYNP,50) 
       CALL mxCopyReal8toPtr(YPL,YPP,50)       
       CALL mxCopyReal8toPtr(XMEAS,XMEASNP,41)
       CALL mxCopyReal8toPtr(XMV,XMVNP,12)
       CALL mxCopyReal8toPtr(WSPACE,WSPACENP,869)
       RETURN
       END
