C      The format of the call is,
C      [time,yy,yp,xmeas,xmv,wspace]=teinit(50)

C      This Program is to interface matlab with TEINIT(NN,TIME,YY,YP)
C      Given NN , which is chosen in matlab, we call TEINIT in
C      FORTRAN initilize TIME YY and YP. 
C
C      Program written by : Palavajjhala Srinivas
C                           Washington Univ., St.Louis,MO 63139.
C
C      This program is the main gateway to MATLAB. 
C      When a MEX function is executed MATLAB calls the USRFCN 
C      Subroutine in the corresponding MEX file
C
C      This part should not be modified
       SUBROUTINE mexFunction(NLHS,PLHS,NRHS,PRHS)
       INTEGER NLHS,NRHS
C      INTEGER*4 PLHS(*),PRHS(*)
       INTEGER PLHS(*),PRHS(*)
C      integer  mxGetM, mxGetPr, mxCreateFull
C      integer  mxCopyReal8ToPtr,mxCopyPtrToReal8
       
C       INTEGER*4 GETSTR
C       INTEGER*4 CRTMAT,REALP,IMAGP,GETGLO,ALREAL,ALINT
C       DOUBLE PRECISION GETSCA
        INTEGER mxGetPr, mxCreateFull

C      This part of the program  is specific for TEINIT
C
C      Declaration of the pointers          
       integer*4  NNP,TIMEP,YYP,YPP,XMEASP,XMVP,wspacep

C      Local Variables are
       DOUBLE PRECISION YYL(50),YPL(50),TIMEL,NNL,wspace(869)

C      COMMON DECLARATIONS
       DOUBLE PRECISION XMEAS,XMV
       integer wteproc1,wwlk1
       double precision wteproc, wwlk, wconst,wrandsd
       common/teproc/wteproc(580),wteproc1(12)
       common/wlk/wwlk(132),wwlk1(12)
       common/const/wconst(112)
       common/randsd/wrandsd
         
       INTEGER IDV,i
       COMMON/PV/XMEAS(41),XMV(12)
       COMMON/DVEC/IDV(20)
C      Check for appropriate inputs

C      Create a matrix for return arguments
       PLHS(1)=mxCreateFull(1,1,0)
       PLHS(2)=mxCreateFull(50,1,0)
       PLHS(3)=mxCreateFull(50,1,0)
       PLHS(4)=mxCreateFull(41,1,0)
       PLHS(5)=mxCreateFull(12,1,0)
       PLHS(6)=mxCreateFull(869,1,0)
       

C      Assign pointers to the parameters
       NNP=mxGetPr(PRHS(1))
       TIMEP=mxGetPr(PLHS(1))
       YYP=mxGetPr(PLHS(2))
       YPP=mxGetPr(PLHS(3))
       XMEASP=mxGetPr(PLHS(4))
       XMVP=mxGetPr(PLHS(5)) 
       wspacep=mxGetPr(PLHS(6))

C      Copying data out of MATLAB into local variables
       CALL mxCopyPtrToReal8(NNP,NNL,1)

C      Call the subroutine
       CALL TEINIT(int(NNL),TIMEL,YYL,YPL)

C      Assign wspace
       do 10  i=1 , 580
10      wspace(i)=wteproc(i)
       do 15 i=581,592
15      wspace(i)=wteproc1(i-580)
       do 20 i=593 ,724 
20       wspace(i)=wwlk(i-592)
       do 25 i=725,736
25       wspace(i)=wwlk1(i-724)
       do 30 i=737 ,848 
30       wspace(i)=wconst(i-736)
       wspace(849)=wrandsd
       do 40 i=850,869
40     wspace(i)=idv(i-849)

C      Copy the data from the local variable into MATLAB return argument

       CALL mxCopyReal8ToPtr(TIMEL,TIMEP,1)

       CALL mxCopyReal8ToPtr(YYL,YYP,50)
       CALL mxCopyReal8ToPtr(YPL,YPP,50)       
       CALL mxCopyReal8toPtr(XMEAS,XMEASP,41)
       CALL mxCopyReal8toPtr(XMV,XMVP,12)
       call mxCopyReal8toPtr(wspace,wspacep,869)
       return
       end
